#include<stdio.h>
#include<string.h>
#include <ctype.h>
#include <time.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>

#include "constantes.h"
#include "typedef.h"

extern void envoi_mail( );


extern  STFICHE *debut,*fin,*fiche;
extern char rep_prog[255];

void trait_saoz(STSAISIEPARAM *psaisie,int year,FILE *fp_log)
{
FILE  *fp_dir,*fp_antar;
char commande[100];
char type[10];
char sujet[100];
char destinataires[100];
char newnom[50];
char date[7];
char ligne[100];
int i,j;
int hh,mm,aa,nn,jj; /* date et heure temporaires */
int jday;
int retour;
char c_jday[4];
time_t secondes;
div_t st_div;
struct tm *tmptr,tmvar;
struct stat st_stat,*pst_stat;
char jour[3],mois[3],an[5];

fprintf(fp_log,"\n*** traitement saoz\n");
	fprintf(fp_log,"fichier: %s\n",fiche->nomfich);

	/* on recupere le jour julien a partir du nom du fichier */
	i=0;
	while(fiche->nomfich[i] < '0' || fiche->nomfich[i] > '9')
		i++;
	j=0;
	while(fiche->nomfich[i] >= '0' && fiche->nomfich[i] <= '9' && j< 3)
		c_jday[j++]=fiche->nomfich[i++];
	c_jday[j]=0;	
	jday=atoi(c_jday);

	if(year < 70 )
		/* on a depasse le 31/12/1999  et on est code sur 2 digits */
		tmvar.tm_year=year+100;
	else if( year < 100 )
		/* on n'a pas depasse le 31/12/1999  et on est code sur 2 digits */
		tmvar.tm_year=year;
	else
		tmvar.tm_year=year-1900;

	tmvar.tm_mon=0;
	tmvar.tm_mday=1;
	tmvar.tm_sec=0;
	tmvar.tm_min=0;
	tmvar.tm_hour=0;
	secondes = mktime(&tmvar);
	secondes += (jday -1) * 3600 *24;
	tmptr = localtime(&secondes);
	sprintf(mois,"%2.2d",tmptr->tm_mon + 1);
	sprintf(jour,"%2.2d",tmptr->tm_mday);
	
	pst_stat=&st_stat;
	retour=stat(fiche->nomfich,pst_stat);
	if(retour == 0)
		{
		/* on recupere la date de derniere modif du fichier */
		tmptr=localtime(&pst_stat->st_ctime);
		/* on prend l'annee sur 2 digits */
		st_div=div(tmptr->tm_year+1900,100);
			
		}
	else
		st_div=div(tmvar.tm_year+1900,100);
			/* on prend l'annee courante sur 2 digits */
					
	sprintf(an,"%2.2d",st_div.rem);


	fprintf(fp_log,"year: %d jday: %d\n",year,jday);
	fprintf(fp_log,"jour: %s mois: %s an: %s\n",jour,mois,an);

	sprintf(newnom,"szd%s%s%s.cra",an,mois,jour);

	sprintf(commande,"cp  %s %s",fiche->nomfich,newnom);
	system(commande);
	/* on enleve les carriage-return eventuels provenant du monde DOS */
	rm_cr(newnom);

    sprintf(date,"%s%s%s",an,mois,jour);

	fprintf(fp_log,"%s -> %s\n",fiche->nomfich,newnom);	
    strcpy(fiche->newnom,newnom);
    strcpy(fiche->date,date);


	sprintf(sujet,"Fichier SAOZ DDU %s du %s/%s/%s",newnom,an,mois,jour);
//	strcpy(destinataires,"mail_saoz.dat");
	sprintf(destinataires,"%s/mail_saoz.dat",rep_prog);
	if(psaisie->mail == VRAI)
		{
		fprintf(fp_log,"envoi email du fichier saoz %s\n",newnom);
		envoi_mail(newnom,sujet,destinataires,fp_log);
		};

}

